/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2010 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

#ifndef __L_SPI_H__
#define __L_SPI_H__


#define SPI_Master      0
#define SPI_Slave       1

#define WRITER_ENABLE   0x06
#define WRITER_DISABLE  0x04
#define READ_DATAE      0x03
#define PAGE_PROGRAM    0x02
#define CHIP_ERASE      0xC7

void SPI_Master_Init(void);
void SPI_Send_1W(uint32_t ulData, uint8_t ucLength);
void SPI_Send_2W(uint32_t ulData_H, uint32_t ulData_L, uint8_t ucLength);
void Get_SPI_Flash_ID(void);
void Program_Page0_Data(void);
void Read_Page0_Data(void);
void Erase_All_Chip(void);
void SPIFLASH_WaitReady(void);
void Program_Page0_DMA_Data(void);
void SPI_Length(uint8_t ucLength);

#endif

