
/**************************************************************************//**
 * @file     main.c
 * @version  V1.00
 * $Revision: 1 $
 * $Date: 12/08/20 11:27a $ 
 * @brief    Main function of this demo is to test access SPI flash.
 *
 * @note
 * Copyright (C) 2011 Nuvoton Technology Corp. All rights reserved.
 *
 ******************************************************************************/


#include <stdio.h>
#include "NUC123Series.h"
#include "L_SPI.h"

                                                                                      
volatile uint8_t comRbuf[512];
volatile uint8_t FlashDone=0;
volatile uint8_t OnePackage[128];
volatile uint8_t PackageSize=0, WriteFlash=0;
volatile uint8_t RX_Index = 0,sum=0;	
volatile uint32_t delay,Add=0,Com_Index = 0;
/**
 * @brief       System init
 *
 * @param       None
 *
 * @return      None
 *
 * @details     Init system clock
 */
void SYS_Init(void)
{
	UNLOCKREG();
    CLK->PWRCON |= CLK_PWRCON_HXT_EN ;	   
    while((CLK->CLKSTATUS & 0x01) == 0);         //HXTȶ
    CLK->CLKDIV  = 0x21;                         //USBƵ,HCLKƵ
    CLK->PLLCON  =  22 ;                         //12MƵ(22+2)Ƶ PLL=144MHz
    while((CLK->CLKSTATUS & 0x04) == 0);         //PLLȶ
	CLK->CLKSEL0 = 0x02 ;	                       //HCLKѡPLL
    CLK->APBCLK  = 0x08000040 ;                  //ʹUSB,FRQDIVʱ
    LOCKREG();
}

/**
 * @brief       UART0 init
 *
 * @param       None
 *
 * @return      None
 *
 * @details     Set UART0 8n1, 115200bps
 */
void UART0_Init(void)
{   
    STR_UART_T sParam;
	
    GPIO_UART0_RXTX_PC();				//En: Set UART0 all pins to PB0=RX,PB1=TX,PB2=RTS,PB3=CTS
	
    /* UART Setting */
    sParam.u32ClkSrc	= CLK_UART_HXT;
    sParam.u32ClkDiv	= 1;
    sParam.u32ClkFreq	= __XTAL;			//HXT/1 == __XTAL
    sParam.u32BaudRate 	= 57600;
    sParam.u32cDataBits = UART_WORD_LEN_8;
    sParam.u32cStopBits = UART_STOP_BIT_1;
    sParam.u32cParity 	= UART_PARITY_NONE;
    sParam.u32cRxTriggerLevel = UART_FCR_RFITL_14BYTES;
    sParam.u32BaudMode  = UART_BAUD_MODE2;
    sParam.u8RxTimeOut	= 100;

    /* Set UART Configuration */
    DrvUART_Init(UART0,&sParam);
    /* Enable UART Interrupt */
    DrvUART_EnableInt(UART0, UART_IER_RDA_IEN|UART_IER_RTO_IEN|UART_IER_TIMEOUT_COUNTER_EN);

}

void UART0_IRQHandler(void)
{	

    if(UART_GET_RDA_INT(UART0)|UART_GET_TOUT_INT(UART0)) //:Ƿж//en:Check if receive interrupt 
    {	
        while(UART_GET_RX_EMPTY(UART0)==0)       //:ջ岻Ϊ//en:Check if received data avaliablet 
        {	
            
            OnePackage[RX_Index]=UART_READ(UART0);  //:ȡַ//en:Read the char	      
			
			if(RX_Index<3)
			{
			   if(OnePackage[0]==0xAA)
			   {
			       PackageSize=36;
				   RX_Index++;
			   }	
			   if(OnePackage[0]==0xAB)
			   {
			       PackageSize=76;
				   RX_Index++;	
			    }
				if(OnePackage[0]==0xAC)
				{
				   FlashDone=1;
				}
				   
			}
			else
//----------------------------------
			if(RX_Index==(PackageSize-1)) 
			{			   
			   if(sum == OnePackage[PackageSize-1])
				   UART_WRITE(UART0, 0xAA); 
			   else
			       UART_WRITE(UART0, 0xEE);
			   sum=0;
			   RX_Index=0;
			}
			else
//----------------------------------			
			if(RX_Index>=3)
			{
				sum = sum + OnePackage[RX_Index];
				comRbuf[Com_Index]=OnePackage[RX_Index];
				Com_Index++;
				if(Com_Index==256)
				{
			       WriteFlash=1;
				}
			    if(Com_Index==512)
			    { 
				   Com_Index=0;
				   WriteFlash=2;
			    }

				RX_Index++;	    
			}
//----------------------------------					         	
        }
    } 
}


void LED_Flash(void)
{
	for(delay=0;delay<300000;delay++);
    GPIO_INVERSE_PIN(PB4);
	for(delay=0;delay<300000;delay++);
    GPIO_INVERSE_PIN(PB4);
	for(delay=0;delay<300000;delay++);
    GPIO_INVERSE_PIN(PB4);
	for(delay=0;delay<300000;delay++);
    GPIO_INVERSE_PIN(PB4);
	for(delay=0;delay<300000;delay++);
    GPIO_INVERSE_PIN(PB4);
	for(delay=0;delay<300000;delay++);
    GPIO_INVERSE_PIN(PB4);
}

void Flash_Verify(void)
{
	FlashDone=Read_One_Data(0x20000);	//0x01
    FlashDone=Read_One_Data(0x20001);	//0x01
	FlashDone=Read_One_Data(0x40000);	//0x00
    FlashDone=Read_One_Data(0x40001);   //0x1C
	
	FlashDone=Read_One_Data(0x41400);	//0x72
    FlashDone=Read_One_Data(0x41401);	//0x15

	FlashDone=Read_One_Data(0x41549);  //0x55
	FlashDone=Read_One_Data(0x4155F);  //0x33


	FlashDone=Read_One_Data(0x5004f);  //C0
	FlashDone=Read_One_Data(0x50050);  //06
	FlashDone=Read_One_Data(0x50051);  //19
	FlashDone=Read_One_Data(0x50100);  //43

    FlashDone=Read_One_Data(0x99B51); //00
	FlashDone=Read_One_Data(0x99A20);  //00
    FlashDone=Read_One_Data(0x99A21);  //C0

	FlashDone=Read_One_Data(0xC9B50);   //00
    FlashDone=Read_One_Data(0xC9B51);   //01
	FlashDone=Read_One_Data(0xC9B52);   //C3
	FlashDone=Read_One_Data(0xC9B5E);	//C3
	FlashDone=Read_One_Data(0xC9B5F);	//00
	while(1);
}
/*---------------------------------------------------------------------------------------------------------*/
/* MAIN function                                                                                           */
/*---------------------------------------------------------------------------------------------------------*/

int main(void)
{
    SYS_Init();	                  //:ϵͳʼ//en:System initiation
    GPIO_SET_MODE(PB, 4, GPIO_OUTPUT);   //En:Configure PB.4 as Output mode
	UART0_Init();                 //:ʼ//en: Initialize UART                                     
    SPI_Master_Init();            //:SPIʼ//en:SPI initiation

//	Flash_Verify();
//---------------------------------------------
	Erase_All_Chip();
	SPIFLASH_WaitReady(); 	  
    LED_Flash();
//=============д16x16ֿ===========================
	while(FlashDone==0)                    
    {
		if(WriteFlash != 0)
		{
//			SPIFLASH_WaitReady();  			 
			Program_Page0_Data();
			GPIO_INVERSE_PIN(PB4);              
		}
		
	}
//--------256ֽڵʣдFlash----------------------	 
		
	if(Com_Index>256)
	     WriteFlash=2;
	else
		 WriteFlash=1;
	Com_Index=0;
	FlashDone=0;
	SPIFLASH_WaitReady();
	Program_Page0_Data(); 

	LED_Flash();
	LED_Flash();		
	
//=================д24x24ֿ=======================
	Add=0x50000;
	while(FlashDone==0)                 
    {
		if(WriteFlash != 0)
		{
//			SPIFLASH_WaitReady();  			 
			Program_Page0_Data();
			GPIO_INVERSE_PIN(PB4);              
		}
	}
//---------256ֽڵʣдFlash---------------------		

	if(Com_Index>256)
	     WriteFlash=2;
	else
		 WriteFlash=1;
	SPIFLASH_WaitReady();
	Program_Page0_Data(); 

	LED_Flash();
	LED_Flash();

//===============ֿд===================
	while(1)
	{
	   for(delay=0;delay<1000000;delay++);
	   GPIO_INVERSE_PIN(PB4);
	}	
}


